diff --git a/keepalived/check/check_file.c b/keepalived/check/check_file.c
index 0f13ebb21..90c9556b8 100644
--- a/keepalived/check/check_file.c
+++ b/keepalived/check/check_file.c
@@ -215,7 +215,7 @@ set_track_file_checkers_down(void)
 						 * work for us. */
 						status = tfl->last_status;
 						tfl->last_status = 0;
-						update_track_file_status(tfl, status);
+						process_update_checker_track_file_status(tfl, !!status == (top->weight_multiplier == 1) ? INT_MIN : 0, top);
 						tfl->last_status = status;
 					} else
 						checker->is_up = false;
diff --git a/keepalived/include/track_file.h b/keepalived/include/track_file.h
index 626766f39..5d5cb0a6d 100644
--- a/keepalived/include/track_file.h
+++ b/keepalived/include/track_file.h
@@ -78,6 +78,7 @@ extern void dump_track_file_list(FILE *, const list_head_t *);
 
 extern void add_obj_to_track_file(void *, tracked_file_monitor_t *, const char *, obj_dump_func_t);
 
+extern void process_update_checker_track_file_status(const tracked_file_t *, int, const tracking_obj_t *);
 extern void update_track_file_status(tracked_file_t *, int);
 
 extern void init_track_files(list_head_t *);
diff --git a/keepalived/trackers/track_file.c b/keepalived/trackers/track_file.c
index c2ea33c2f..175dd8650 100644
--- a/keepalived/trackers/track_file.c
+++ b/keepalived/trackers/track_file.c
@@ -578,7 +578,7 @@ process_update_vrrp_track_file_status(const tracked_file_t *tfile, int new_statu
 #endif
 
 #ifdef _WITH_LVS_
-static void
+void
 process_update_checker_track_file_status(const tracked_file_t *tfile, int new_status, const tracking_obj_t *top)
 {
 	int previous_status;
